(*
NetioDemoDelphi.pas - Demo program to show how to use the NETIO-230 with an
                      Delphi applicaton
Version:     1.0
Date:        25.10.2010
Company:     antrax Datentechnik GmbH
Uses with:   Koukaam NETIO-230A (Firmwareversion V2.33)
*)

unit NetioDemoDelphi;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdTelnet;

type
  TFormMain = class(TForm)
    LabelPort1: TLabel;
    LabelPort2: TLabel;
    LabelPort3: TLabel;
    EditUser: TEdit;
    LabelPort4: TLabel;
    ButtonP1ON: TButton;
    ButtonP1OFF: TButton;
    ButtonP2ON: TButton;
    ButtonP2OFF: TButton;
    ButtonP3ON: TButton;
    ButtonP3OFF: TButton;
    ButtonP4ON: TButton;
    ButtonP4OFF: TButton;
    LabelUser: TLabel;
    LabelPassword: TLabel;
    EditPassword: TEdit;
    LabelIPAdress: TLabel;
    EditIP: TEdit;
    ButtonLogin: TButton;
    IdTelnet1: TIdTelnet;
    MemoOutput: TMemo;
    procedure ButtonLoginClick(Sender: TObject);
    procedure ButtonP1ONClick(Sender: TObject);
    procedure ButtonP1OFFClick(Sender: TObject);
    procedure ButtonP2ONClick(Sender: TObject);
    procedure ButtonP2OFFClick(Sender: TObject);
    procedure ButtonP3ONClick(Sender: TObject);
    procedure ButtonP3OFFClick(Sender: TObject);
    procedure ButtonP4ONClick(Sender: TObject);
    procedure ButtonP4OFFClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure IdTelnet1DataAvailable(Sender: TIdTelnet; const Buffer: string);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

//------------------------------------------------------------------------------
// connect to the NETIO-230A ---------------------------------------------------
//------------------------------------------------------------------------------
procedure TFormMain.ButtonLoginClick(Sender: TObject);
begin
  IdTelnet1.Host := EditIP.Text;
  IdTelnet1.Port := 1234;         // firmwareversion V2.30 and later
  IdTelnet1.Connect;              // Connect to the Netio via telnet

  // login with inserted account-informations
  IdTelnet1.Socket.WriteLn('login ' + EditUser.Text + ' ' + EditPassword.Text);
end;

//------------------------------------------------------------------------------
// button functions ------------------------------------------------------------
//------------------------------------------------------------------------------
procedure TFormMain.ButtonP1OFFClick(Sender: TObject);
begin
  IdTelnet1.Socket.WriteLn('port 1 0'); // Switch off
end;

procedure TFormMain.ButtonP1ONClick(Sender: TObject);
begin
  IdTelnet1.Socket.WriteLn('port 1 1'); // Switch on
end;

procedure TFormMain.ButtonP2OFFClick(Sender: TObject);
begin
  IdTelnet1.Socket.WriteLn('port 2 0'); // Switch off
end;

procedure TFormMain.ButtonP2ONClick(Sender: TObject);
begin
  IdTelnet1.Socket.WriteLn('port 2 1'); // Switch on
end;

procedure TFormMain.ButtonP3OFFClick(Sender: TObject);
begin
  IdTelnet1.Socket.WriteLn('port 3 0'); // Switch off
end;

procedure TFormMain.ButtonP3ONClick(Sender: TObject);
begin
  IdTelnet1.Socket.WriteLn('port 3 1'); // Switch on
end;

procedure TFormMain.ButtonP4OFFClick(Sender: TObject);
begin
  IdTelnet1.Socket.WriteLn('port 4 0'); // Switch off
end;

procedure TFormMain.ButtonP4ONClick(Sender: TObject);
begin
  IdTelnet1.Socket.WriteLn('port 4 1'); // Switch on
end;

//------------------------------------------------------------------------------
// close program --> disconnect telnet -----------------------------------------
//------------------------------------------------------------------------------
procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IdTelnet1.Disconnect();
end;

//------------------------------------------------------------------------------
// show received data in an memo -----------------------------------------------
//------------------------------------------------------------------------------
procedure TFormMain.IdTelnet1DataAvailable(Sender: TIdTelnet;
  const Buffer: string);
begin
  MemoOutput.Lines.Add(Buffer);
end;

end.
